'use strict';

var redLiveCallbacksStoreBefore = new Map();
var redLiveCallbacksStoreAfter = new Map();
var bindFnOnType = function (actionType, callback, store) {
    if (!Array.isArray(store.get(actionType))) {
        store.set(actionType, []);
    }
    var actionStack = store.get(actionType);
    if (actionStack)
        actionStack.push(callback);
};
var redLiveSubBefore = function (actionType, callback) {
    if (Array.isArray(actionType)) {
        for (var _i = 0, actionType_1 = actionType; _i < actionType_1.length; _i++) {
            var type = actionType_1[_i];
            bindFnOnType(type, callback, redLiveCallbacksStoreBefore);
        }
    }
    else {
        bindFnOnType(actionType, callback, redLiveCallbacksStoreBefore);
    }
};
var redLiveSubAfter = function (actionType, callback) {
    if (Array.isArray(actionType)) {
        for (var _i = 0, actionType_2 = actionType; _i < actionType_2.length; _i++) {
            var type = actionType_2[_i];
            bindFnOnType(type, callback, redLiveCallbacksStoreAfter);
        }
    }
    else {
        bindFnOnType(actionType, callback, redLiveCallbacksStoreAfter);
    }
};
var redLiveMiddleware = function () { return function (next) { return function (action) {
    var afterStack = redLiveCallbacksStoreAfter.get(action.type);
    var beforeStack = redLiveCallbacksStoreBefore.get(action.type);
    if (beforeStack) {
        for (var _i = 0, beforeStack_1 = beforeStack; _i < beforeStack_1.length; _i++) {
            var f = beforeStack_1[_i];
            f(action);
        }
    }
    var result = next(action);
    if (afterStack) {
        for (var _a = 0, afterStack_1 = afterStack; _a < afterStack_1.length; _a++) {
            var f = afterStack_1[_a];
            f(action);
        }
    }
    return result;
}; }; };

exports.redLiveMiddleware = redLiveMiddleware;
exports.redLiveSubAfter = redLiveSubAfter;
exports.redLiveSubBefore = redLiveSubBefore;
//# sourceMappingURL=index.cjs.map
